package com.faraphel.tasks_valider.connectivity

import android.util.Log
import java.net.ServerSocket


class DemoServer(port: Int) {

    companion object {
        var SOCKET_TIMEOUT = 120 * 1000  ///< TEST(Faraphel): long timeout for testing
    }

    private var server = ServerSocket(port)

    init {
        server.soTimeout = SOCKET_TIMEOUT
    }

    /**
     * Accept and treat a client once
     */
    private fun once() {
        // wait for a client connexion
        Log.d("demo-server", "waiting for a client...")
        val client = server.accept()
        Log.d("demo-server", "client connected !")

        // once connected, wait and read a byte from the client.
        val value = client.getInputStream().read()
        Log.d("demo-server", "client sent data : $value")

        // TODO(Faraphel): an abstraction layer should be added in the future to receive type of packets and read the data
    }

    /**
     * Accept and threat clients indefinitely
     */
    fun start() {
        Thread {
            while (true) {
                try {
                    this.once()
                } catch (exception: Exception) {
                    Log.w("demo-server", "an error occured: $exception")
                }
                Thread.sleep(1000)
            }
        }.start()
    }
}
