package com.faraphel.tasks_valider.connectivity.wifi_p2p

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.net.wifi.p2p.WifiP2pManager
import android.util.Log

class WifiP2pBroadcastReceiver(
    private val manager: WifiP2pManager,
    private val channel: WifiP2pManager.Channel,
) : BroadcastReceiver() {
    companion object {
        val INTENT_FILTER = IntentFilter().apply {
            addAction(WifiP2pManager.WIFI_P2P_STATE_CHANGED_ACTION)
            addAction(WifiP2pManager.WIFI_P2P_PEERS_CHANGED_ACTION)
            addAction(WifiP2pManager.WIFI_P2P_CONNECTION_CHANGED_ACTION)
            addAction(WifiP2pManager.WIFI_P2P_THIS_DEVICE_CHANGED_ACTION)
        }
    }

    override fun onReceive(context: Context?, intent: Intent) {
        when (intent.action) {
            WifiP2pManager.WIFI_P2P_CONNECTION_CHANGED_ACTION -> {
                Log.i("wifi-p2p", "Connection Changed : $context, $intent, ${intent.extras}")
            }
            WifiP2pManager.WIFI_P2P_PEERS_CHANGED_ACTION -> {
                Log.i("wifi-p2p", "Peers Changed : $context, $intent, ${intent.extras}")
            }
            WifiP2pManager.WIFI_P2P_STATE_CHANGED_ACTION -> {
                Log.i("wifi-p2p", "State Changed : $context, $intent, ${intent.extras}")
            }
            WifiP2pManager.WIFI_P2P_THIS_DEVICE_CHANGED_ACTION -> {
                Log.i("wifi-p2p", "This Device Changed : $context, $intent, ${intent.extras}")
            }
        }
    }
}